#include "mpi.h"

int addem(invec, inoutvec, len)
int *invec, *inoutvec, len;
{
  int i;
  for ( i=0; i<len; i++ ) 
    inoutvec[i] += invec[i];
  return (1);
}

worker( argc, argv )
int argc;
char **argv;
{
    int              rank, size, i;
    MPI_Comm_request handle;
    MPI_Status       status;
    int              data;
    int              errors=0;
    int              result = -100;
    int              correct_result;

    MPI_Init( &argc, argv );
    MPI_Comm_rank( MPI_COMM_WORLD, &rank );
    MPI_Comm_size( MPI_COMM_WORLD, &size );

    data = rank;

    MPI_User_reduce ( &data, &result, 1, MPI_INT, addem, 0, MPI_COMM_WORLD );
    MPI_Bcast  ( &result, 1, MPI_INT, 0, MPI_COMM_WORLD );
    correct_result = 0;
    for(i=0;i<size;i++) 
      correct_result += i;
    if (result != correct_result) errors++;

    MPI_Finalize();
    if (errors)
      printf( "[%d] done with ERRORS(%d)!\n", rank, errors );
    else
      printf( "[%d] SUCCESSFUL!\n", rank );
}
